import d from "../../../@babel/runtime/helpers/esm/objectSpread2.rd.js";
import { defineComponent as _, computed as L, ref as C, inject as I, createVNode as f, provide as j, Fragment as U } from "vue";
import u from "../_util/vue-types/index.rd.js";
import c from "../vc-util/Dom/contains.rd.js";
import v from "../_util/raf.rd.js";
import { findDOMNode as m, getComponent as z, hasProp as G, getEvents as b, filterEmpty as X, getSlot as Y } from "../_util/props-util/index.rd.js";
import { requestAnimationTimeout as q, cancelAnimationTimeout as W } from "../_util/requestAnimationTimeout.rd.js";
import g from "../vc-util/Dom/addEventListener.rd.js";
import J from "./Popup/index.rd.js";
import { getAlignFromPlacement as w, getAlignPopupClassName as K } from "./utils/alignUtil.rd.js";
import Q from "../_util/BaseMixin.rd.js";
import x from "../_util/Portal.rd.js";
import Z from "../_util/classNames.rd.js";
import { cloneElement as ee } from "../_util/vnode.rd.js";
import P from "../_util/supportsPassive.rd.js";
import { useInjectTrigger as te, useProvidePortal as oe } from "./context.rd.js";
function y() {
}
function ie() {
  return "";
}
function ne(i) {
  return i ? i.ownerDocument : window.document;
}
var se = ["onClick", "onMousedown", "onTouchstart", "onMouseenter", "onMouseleave", "onFocus", "onBlur", "onContextmenu"];
const we = _({
  compatConfig: {
    MODE: 3
  },
  name: "Trigger",
  mixins: [Q],
  inheritAttrs: !1,
  props: {
    action: u.oneOfType([u.string, u.arrayOf(u.string)]).def([]),
    showAction: u.any.def([]),
    hideAction: u.any.def([]),
    getPopupClassNameFromAlign: u.any.def(ie),
    onPopupVisibleChange: Function,
    afterPopupVisibleChange: u.func.def(y),
    popup: u.any,
    popupStyle: {
      type: Object,
      default: void 0
    },
    prefixCls: u.string.def("rc-trigger-popup"),
    popupClassName: u.string.def(""),
    popupPlacement: String,
    builtinPlacements: u.object,
    popupTransitionName: String,
    popupAnimation: u.any,
    mouseEnterDelay: u.number.def(0),
    mouseLeaveDelay: u.number.def(0.1),
    zIndex: Number,
    focusDelay: u.number.def(0),
    blurDelay: u.number.def(0.15),
    getPopupContainer: Function,
    getDocument: u.func.def(ne),
    forceRender: {
      type: Boolean,
      default: void 0
    },
    destroyPopupOnHide: {
      type: Boolean,
      default: !1
    },
    mask: {
      type: Boolean,
      default: !1
    },
    maskClosable: {
      type: Boolean,
      default: !0
    },
    popupAlign: u.object.def(function() {
      return {};
    }),
    popupVisible: {
      type: Boolean,
      default: void 0
    },
    defaultPopupVisible: {
      type: Boolean,
      default: !1
    },
    maskTransitionName: String,
    maskAnimation: String,
    stretch: String,
    alignPoint: {
      type: Boolean,
      default: void 0
    },
    autoDestroy: {
      type: Boolean,
      default: !1
    },
    mobile: Object,
    getTriggerDOMNode: Function,
    tryPopPortal: Boolean
  },
  setup: function(e) {
    var o = L(function() {
      var p = e.popupPlacement, h = e.popupAlign, l = e.builtinPlacements;
      return p && l ? w(l, p, h) : h;
    }), t = te(e.tryPopPortal), s = t.setPortal, a = t.popPortal, n = C(null), r = function(h) {
      n.value = h;
    };
    return {
      popPortal: a,
      setPortal: s,
      vcTriggerContext: I("vcTriggerContext", {}),
      popupRef: n,
      setPopupRef: r,
      triggerRef: C(null),
      align: o,
      focusTime: null,
      clickOutsideHandler: null,
      contextmenuOutsideHandler1: null,
      contextmenuOutsideHandler2: null,
      touchOutsideHandler: null,
      attachId: null,
      delayTimer: null,
      hasPopupMouseDown: !1,
      preClickTime: null,
      preTouchTime: null,
      mouseDownTimeout: null,
      childOriginEvents: {}
    };
  },
  data: function() {
    var e = this, o, t = this.$props, s;
    return this.popupVisible !== void 0 ? s = !!t.popupVisible : s = !!t.defaultPopupVisible, se.forEach(function(a) {
      e["fire".concat(a)] = function(n) {
        e.fireEvents(a, n);
      };
    }), (o = this.setPortal) === null || o === void 0 || o.call(this, f(x, {
      key: "portal",
      getContainer: this.getContainer,
      didUpdate: this.handlePortalUpdate
    }, {
      default: this.getComponent
    })), {
      prevPopupVisible: s,
      sPopupVisible: s,
      point: null
    };
  },
  watch: {
    popupVisible: function(e) {
      e !== void 0 && (this.prevPopupVisible = this.sPopupVisible, this.sPopupVisible = e);
    }
  },
  created: function() {
    j("vcTriggerContext", {
      onPopupMouseDown: this.onPopupMouseDown
    }), oe(this);
  },
  deactivated: function() {
    this.setPopupVisible(!1);
  },
  mounted: function() {
    var e = this;
    this.$nextTick(function() {
      e.updatedCal();
    });
  },
  updated: function() {
    var e = this;
    this.$nextTick(function() {
      e.updatedCal();
    });
  },
  beforeUnmount: function() {
    this.clearDelayTimer(), this.clearOutsideHandler(), clearTimeout(this.mouseDownTimeout), v.cancel(this.attachId);
  },
  methods: {
    updatedCal: function() {
      var e = this.$props, o = this.$data;
      if (o.sPopupVisible) {
        var t;
        !this.clickOutsideHandler && (this.isClickToHide() || this.isContextmenuToShow()) && (t = e.getDocument(this.getRootDomNode()), this.clickOutsideHandler = g(t, "mousedown", this.onDocumentClick)), this.touchOutsideHandler || (t = t || e.getDocument(this.getRootDomNode()), this.touchOutsideHandler = g(t, "touchstart", this.onDocumentClick, P ? {
          passive: !1
        } : !1)), !this.contextmenuOutsideHandler1 && this.isContextmenuToShow() && (t = t || e.getDocument(this.getRootDomNode()), this.contextmenuOutsideHandler1 = g(t, "scroll", this.onContextmenuClose)), !this.contextmenuOutsideHandler2 && this.isContextmenuToShow() && (this.contextmenuOutsideHandler2 = g(window, "blur", this.onContextmenuClose));
      } else
        this.clearOutsideHandler();
    },
    onMouseenter: function(e) {
      var o = this.$props.mouseEnterDelay;
      this.fireEvents("onMouseenter", e), this.delaySetPopupVisible(!0, o, o ? null : e);
    },
    onMouseMove: function(e) {
      this.fireEvents("onMousemove", e), this.setPoint(e);
    },
    onMouseleave: function(e) {
      this.fireEvents("onMouseleave", e), this.delaySetPopupVisible(!1, this.$props.mouseLeaveDelay);
    },
    onPopupMouseenter: function() {
      this.clearDelayTimer();
    },
    onPopupMouseleave: function(e) {
      var o;
      e && e.relatedTarget && !e.relatedTarget.setTimeout && c((o = this.popupRef) === null || o === void 0 ? void 0 : o.getElement(), e.relatedTarget) || this.delaySetPopupVisible(!1, this.$props.mouseLeaveDelay);
    },
    onFocus: function(e) {
      this.fireEvents("onFocus", e), this.clearDelayTimer(), this.isFocusToShow() && (this.focusTime = Date.now(), this.delaySetPopupVisible(!0, this.$props.focusDelay));
    },
    onMousedown: function(e) {
      this.fireEvents("onMousedown", e), this.preClickTime = Date.now();
    },
    onTouchstart: function(e) {
      this.fireEvents("onTouchstart", e), this.preTouchTime = Date.now();
    },
    onBlur: function(e) {
      c(e.target, e.relatedTarget || document.activeElement) || (this.fireEvents("onBlur", e), this.clearDelayTimer(), this.isBlurToHide() && this.delaySetPopupVisible(!1, this.$props.blurDelay));
    },
    onContextmenu: function(e) {
      e.preventDefault(), this.fireEvents("onContextmenu", e), this.setPopupVisible(!0, e);
    },
    onContextmenuClose: function() {
      this.isContextmenuToShow() && this.close();
    },
    onClick: function(e) {
      if (this.fireEvents("onClick", e), this.focusTime) {
        var o;
        if (this.preClickTime && this.preTouchTime ? o = Math.min(this.preClickTime, this.preTouchTime) : this.preClickTime ? o = this.preClickTime : this.preTouchTime && (o = this.preTouchTime), Math.abs(o - this.focusTime) < 20)
          return;
        this.focusTime = 0;
      }
      this.preClickTime = 0, this.preTouchTime = 0, this.isClickToShow() && (this.isClickToHide() || this.isBlurToHide()) && e && e.preventDefault && e.preventDefault(), e && e.domEvent && e.domEvent.preventDefault();
      var t = !this.$data.sPopupVisible;
      (this.isClickToHide() && !t || t && this.isClickToShow()) && this.setPopupVisible(!this.$data.sPopupVisible, e);
    },
    onPopupMouseDown: function() {
      var e = this, o = this.vcTriggerContext, t = o === void 0 ? {} : o;
      this.hasPopupMouseDown = !0, clearTimeout(this.mouseDownTimeout), this.mouseDownTimeout = setTimeout(function() {
        e.hasPopupMouseDown = !1;
      }, 0), t.onPopupMouseDown && t.onPopupMouseDown.apply(t, arguments);
    },
    onDocumentClick: function(e) {
      if (!(this.$props.mask && !this.$props.maskClosable)) {
        var o = e.target, t = this.getRootDomNode(), s = this.getPopupDomNode();
        (!c(t, o) || this.isContextMenuOnly()) && !c(s, o) && !this.hasPopupMouseDown && this.delaySetPopupVisible(!1, 0.1);
      }
    },
    getPopupDomNode: function() {
      var e;
      return ((e = this.popupRef) === null || e === void 0 ? void 0 : e.getElement()) || null;
    },
    getRootDomNode: function() {
      var e = this.$props.getTriggerDOMNode;
      if (e) {
        var o = m(this.triggerRef);
        return m(e(o));
      }
      try {
        var t = m(this.triggerRef);
        if (t)
          return t;
      } catch {
      }
      return m(this);
    },
    handleGetPopupClassFromAlign: function(e) {
      var o = [], t = this.$props, s = t.popupPlacement, a = t.builtinPlacements, n = t.prefixCls, r = t.alignPoint, p = t.getPopupClassNameFromAlign;
      return s && a && o.push(K(a, n, e, r)), p && o.push(p(e)), o.join(" ");
    },
    getPopupAlign: function() {
      var e = this.$props, o = e.popupPlacement, t = e.popupAlign, s = e.builtinPlacements;
      return o && s ? w(s, o, t) : t;
    },
    getComponent: function() {
      var e = this, o = {};
      this.isMouseEnterToShow() && (o.onMouseenter = this.onPopupMouseenter), this.isMouseLeaveToHide() && (o.onMouseleave = this.onPopupMouseleave), o.onMousedown = this.onPopupMouseDown, o[P ? "onTouchstartPassive" : "onTouchstart"] = this.onPopupMouseDown;
      var t = this.handleGetPopupClassFromAlign, s = this.getRootDomNode, a = this.getContainer, n = this.$attrs, r = this.$props, p = r.prefixCls, h = r.destroyPopupOnHide, l = r.popupClassName, M = r.popupAnimation, D = r.popupTransitionName, O = r.popupStyle, $ = r.mask, k = r.maskAnimation, A = r.maskTransitionName, H = r.zIndex, V = r.stretch, N = r.alignPoint, S = r.mobile, E = r.forceRender, T = this.$data, R = T.sPopupVisible, F = T.point, B = d(d({
        prefixCls: p,
        destroyPopupOnHide: h,
        visible: R,
        point: N ? F : null,
        align: this.align,
        animation: M,
        getClassNameFromAlign: t,
        stretch: V,
        getRootDomNode: s,
        mask: $,
        zIndex: H,
        transitionName: D,
        maskAnimation: k,
        maskTransitionName: A,
        getContainer: a,
        class: l,
        style: O,
        onAlign: n.onPopupAlign || y
      }, o), {}, {
        ref: this.setPopupRef,
        mobile: S,
        forceRender: E
      });
      return f(J, B, {
        default: this.$slots.popup || function() {
          return z(e, "popup");
        }
      });
    },
    attachParent: function(e) {
      var o = this;
      v.cancel(this.attachId);
      var t = this.$props, s = t.getPopupContainer, a = t.getDocument, n = this.getRootDomNode(), r;
      s ? (n || s.length === 0) && (r = s(n)) : r = a(this.getRootDomNode()).body, r ? r.appendChild(e) : this.attachId = v(function() {
        o.attachParent(e);
      });
    },
    getContainer: function() {
      var e = this.$props, o = e.getDocument, t = o(this.getRootDomNode()).createElement("div");
      return t.style.position = "absolute", t.style.top = "0", t.style.left = "0", t.style.width = "100%", this.attachParent(t), t;
    },
    setPopupVisible: function(e, o) {
      var t = this.alignPoint, s = this.sPopupVisible, a = this.onPopupVisibleChange;
      this.clearDelayTimer(), s !== e && (G(this, "popupVisible") || this.setState({
        sPopupVisible: e,
        prevPopupVisible: s
      }), a && a(e)), t && o && e && this.setPoint(o);
    },
    setPoint: function(e) {
      var o = this.$props.alignPoint;
      !o || !e || this.setState({
        point: {
          pageX: e.pageX,
          pageY: e.pageY
        }
      });
    },
    handlePortalUpdate: function() {
      this.prevPopupVisible !== this.sPopupVisible && this.afterPopupVisibleChange(this.sPopupVisible);
    },
    delaySetPopupVisible: function(e, o, t) {
      var s = this, a = o * 1e3;
      if (this.clearDelayTimer(), a) {
        var n = t ? {
          pageX: t.pageX,
          pageY: t.pageY
        } : null;
        this.delayTimer = q(function() {
          s.setPopupVisible(e, n), s.clearDelayTimer();
        }, a);
      } else
        this.setPopupVisible(e, t);
    },
    clearDelayTimer: function() {
      this.delayTimer && (W(this.delayTimer), this.delayTimer = null);
    },
    clearOutsideHandler: function() {
      this.clickOutsideHandler && (this.clickOutsideHandler.remove(), this.clickOutsideHandler = null), this.contextmenuOutsideHandler1 && (this.contextmenuOutsideHandler1.remove(), this.contextmenuOutsideHandler1 = null), this.contextmenuOutsideHandler2 && (this.contextmenuOutsideHandler2.remove(), this.contextmenuOutsideHandler2 = null), this.touchOutsideHandler && (this.touchOutsideHandler.remove(), this.touchOutsideHandler = null);
    },
    createTwoChains: function(e) {
      var o = function() {
      }, t = b(this);
      return this.childOriginEvents[e] && t[e] ? this["fire".concat(e)] : (o = this.childOriginEvents[e] || t[e] || o, o);
    },
    isClickToShow: function() {
      var e = this.$props, o = e.action, t = e.showAction;
      return o.indexOf("click") !== -1 || t.indexOf("click") !== -1;
    },
    isContextMenuOnly: function() {
      var e = this.$props.action;
      return e === "contextmenu" || e.length === 1 && e[0] === "contextmenu";
    },
    isContextmenuToShow: function() {
      var e = this.$props, o = e.action, t = e.showAction;
      return o.indexOf("contextmenu") !== -1 || t.indexOf("contextmenu") !== -1;
    },
    isClickToHide: function() {
      var e = this.$props, o = e.action, t = e.hideAction;
      return o.indexOf("click") !== -1 || t.indexOf("click") !== -1;
    },
    isMouseEnterToShow: function() {
      var e = this.$props, o = e.action, t = e.showAction;
      return o.indexOf("hover") !== -1 || t.indexOf("mouseenter") !== -1;
    },
    isMouseLeaveToHide: function() {
      var e = this.$props, o = e.action, t = e.hideAction;
      return o.indexOf("hover") !== -1 || t.indexOf("mouseleave") !== -1;
    },
    isFocusToShow: function() {
      var e = this.$props, o = e.action, t = e.showAction;
      return o.indexOf("focus") !== -1 || t.indexOf("focus") !== -1;
    },
    isBlurToHide: function() {
      var e = this.$props, o = e.action, t = e.hideAction;
      return o.indexOf("focus") !== -1 || t.indexOf("blur") !== -1;
    },
    forcePopupAlign: function() {
      if (this.$data.sPopupVisible) {
        var e;
        (e = this.popupRef) === null || e === void 0 || e.forceAlign();
      }
    },
    fireEvents: function(e, o) {
      this.childOriginEvents[e] && this.childOriginEvents[e](o);
      var t = this.$props[e] || this.$attrs[e];
      t && t(o);
    },
    close: function() {
      this.setPopupVisible(!1);
    }
  },
  render: function() {
    var e = this, o = this.$attrs, t = X(Y(this)), s = this.$props.alignPoint, a = t[0];
    this.childOriginEvents = b(a);
    var n = {
      key: "trigger"
    };
    this.isContextmenuToShow() ? n.onContextmenu = this.onContextmenu : n.onContextmenu = this.createTwoChains("onContextmenu"), this.isClickToHide() || this.isClickToShow() ? (n.onClick = this.onClick, n.onMousedown = this.onMousedown, n[P ? "onTouchstartPassive" : "onTouchstart"] = this.onTouchstart) : (n.onClick = this.createTwoChains("onClick"), n.onMousedown = this.createTwoChains("onMousedown"), n[P ? "onTouchstartPassive" : "onTouchstart"] = this.createTwoChains("onTouchstart")), this.isMouseEnterToShow() ? (n.onMouseenter = this.onMouseenter, s && (n.onMousemove = this.onMouseMove)) : n.onMouseenter = this.createTwoChains("onMouseenter"), this.isMouseLeaveToHide() ? n.onMouseleave = this.onMouseleave : n.onMouseleave = this.createTwoChains("onMouseleave"), this.isFocusToShow() || this.isBlurToHide() ? (n.onFocus = this.onFocus, n.onBlur = this.onBlur) : (n.onFocus = this.createTwoChains("onFocus"), n.onBlur = function(l) {
      l && (!l.relatedTarget || !c(l.target, l.relatedTarget)) && e.createTwoChains("onBlur")(l);
    });
    var r = Z(a && a.props && a.props.class, o.class);
    r && (n.class = r);
    var p = ee(a, d(d({}, n), {}, {
      ref: "triggerRef"
    }), !0, !0);
    if (this.popPortal)
      return p;
    var h = f(x, {
      key: "portal",
      getContainer: this.getContainer,
      didUpdate: this.handlePortalUpdate
    }, {
      default: this.getComponent
    });
    return f(U, null, [h, p]);
  }
});
export {
  we as default
};
